pro cal_031013_1565

input_dir = '/nfs/export/scr2/lvtt/T990_firs/'
output_dir = '/data/cbeck/reduced_031013/'
change_save = '/data/cbeck/reduced_031013/'

;get_firs_dataprop,input_dir,change_save =change_save



; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 10 03
types1 = [0,1,0,2,1,2,2,2,1,0,0,16,16,2,2,1,0]

pp = 0
if pp eq 1 then begin

; 4.00000      134.000      142.000      247.000      277.000
; 370.000      402.000      491.000

yyrange = [5,500,515,1016]/2.

;firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 2,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5

;firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 2,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5

;firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5

;firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 10,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,/avdc_only

 ;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 11,darkindex= 1,gainindex = 1,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_err = 5.,/no_av

 ;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 12,darkindex= 1,gainindex = 1,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_pol = 45.,theta_err = 5.,/nopause,/no_av


endif

pp = 0
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'
cal_file  = 11

pos_lines = [71,148]

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  5,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  6,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  7,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  13,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  14,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,/no_align,pos_lines = pos_lines

endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/031013/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2,wavelen = 15650.,pollimit = .001

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
