pro cal_040614_1565

; directory to input raw data
input_dir = '/home/cbeck/040614/'

; directory for output data
output_dir = '/home/cbeck/040614_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save = '/home/cbeck/040614_reduced/' 

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations

 
; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
types1 = [1,0,0,2,1,0,0,2,1,0,2,16,16,16,1]




pp = 0
if pp eq 1 then begin

yyrange = [4,508,512,1015]/2.

; 4 slits, 1565

; Attention: bad correlation in one beam. Use keyword /shifts_manual,
; and then answer: rotation: 0 <cr> ; initial value: 0 <cr>; accept: y
; <cr>; shifts x: 2,1,1,0 <cr>; shifts_y: 7,8,7,7 <cr>

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 5,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 6,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,/swap,yyrange = yyrange,/avdc_only

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,/swap,yyrange = yyrange

; end Attention

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 12,darkindex= 3,gainindex = 2,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/swap

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,theta_pol = 45.,/swap,/nopause

endif


pp = 1
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft2_181013/Tmatrix_May2010_4708-14125.idl'
cal_file = 12

wavelength = 15650.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 1,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap,/check_lines


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 3,gainindex = 2,change_save =change_save,obsindex =  7,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 3,gainindex = 2,change_save =change_save,obsindex =  10,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap,/check_lines ;,/no_align

endif


inpath = output_dir
outpath = '/home/cbeck/work/FIRS_archive/2014/040614/'

iinput_dir = '/home/cbeck/040614/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2.5,wavelen = 1565.,pollimit = .002,iinput_dir = iinput_dir

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/home/cbeck/work/FIRS_archive/FIRS_archivemain.html'
 inpath = '/home/cbeck/work/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
