pro cal_160413_630


input_dir = '/nfs/export/scr2/cbeck/obs2013/160413/firs1/'
output_dir = '/export/cbeck/obs2013/firs_april2013/160413_reduced_630/'
;spawn,'mkdir '+output_dir

change_save = '/export/cbeck/obs2013/firs_april2013/160413_reduced_630/' 

pp = 0
if pp eq 1 then begin
   get_firs_dataprop,input_dir,change_save =change_save
endif

; 16 cal   2 map  1 ff 0 dc

types1 = [2,2,2,2,0,1,2,2,1,0,16,16,16,16,16,0,2]

pp = 0
if pp eq 1 then begin

firs_630_ff,change_save = change_save,flat_file = 5,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,yyrange = [0,511,512,1022]

firs_630_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,yyrange = [0,511,512,1022]

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 10,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 5,retard = 88.

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 11,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 5,retard = 88.,theta_pol = 45.

endif


pp = 1
if pp eq 1 then begin

cal_file = 10
tmat_save = '/home/cbeck/laptop_teneriffa/telcal_DST/Tmatrix_May2010_4708-14125.idl'

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  1,angle = 0,tmat_save = tmat_save

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file =  cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,angle = 0,tmat_save = tmat_save

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  3,angle = 0,tmat_save = tmat_save

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file =  cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  6,angle = 0,tmat_save = tmat_save

endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/160413/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2,wavelen = 630.,pollimit = .01 ;,wwidth = 3

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
