pro cal_180913_1565

input_dir = '/net/zeeman2/export/data/scriscuo/t988/18_sep_2013/coconut/'
output_dir = '/data/cbeck/reduced_180913/'
change_save = '/data/cbeck/reduced_180913/'

;get_firs_dataprop,input_dir,change_save =change_save



; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 10 03
types1 = [1,2,2,2,1,2,1,2,2,2,0,0,16,16,1,0]

pp = 0
if pp eq 1 then begin

; 4.00000      134.000      142.000      247.000      277.000
; 370.000      402.000      491.000

yyrange = [5,500,515,1016]/2.


;firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 10,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed = .5


;firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 10,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed = .5

;firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 10,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed = .5

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 12,darkindex= 0,gainindex = 0,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_err = 5.

 firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 13,darkindex= 0,gainindex = 0,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_pol = 45.,theta_err = 5.,/nopause


endif

pp = 1
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'
cal_file  = 13

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  1,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

;firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 1,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 1,change_save =change_save,obsindex =  5,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 2,change_save =change_save,obsindex =  7,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 2,change_save =change_save,obsindex =  8,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 2,change_save =change_save,obsindex =  9,tmat_save = tmat_save,wavelength = 15650.,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/no_align,smooth_width = 3,/check_lines

endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/180913/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2,wavelen = 15650.,pollimit = .001

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
