pro cal_190815_589

wavelength = 5896.

; directory to input raw data
input_dir = '/data/cbeck/obs2015/obs_egidio_roberto_aug2015/19_aug_2015/5896/'

; directory for output data
output_dir = '/data/cbeck/obs2015/obs_egidio_roberto_aug2015/190815_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/data/cbeck/obs2015/obs_egidio_roberto_aug2015/190815_reduced/'

pp = 0
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations, edit the rest below correspondingly

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2014 03 22
;types1 = [1,0,2,1,0,2,2,1,0,2,2,16,16,1,0]

binning = 2.

pp = 1
if pp eq 1 then begin

yyrange = [0,495,525,1023]

;sshift = [0,-20]

firs_1083_ff,change_save = change_save,flat_file = 3,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,yyrange = yyrange,sshift = sshift,binning = binning


firs_1083_ff,change_save = change_save,flat_file = 15,dark_file = 16,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,yyrange = yyrange,sshift = sshift,binning = binning


firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save,theta_err = 4,flat_file = flat_file,retard = 87.,/quit_column,/nopause

;stop


endif


pp = 1
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

cal_file = 5


cont_wl = [1220,1240]
pos_lines = [427,1431]   ; 827,1431

beta = 0.035


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 0,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning,/nopause,beta = beta ;,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 1,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning,/nopause,beta = beta   ;,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 2,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning ,/nopause,beta = beta  ;,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 7,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning,/nopause  ;,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 8,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning,/nopause   ;,/check_lines


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 14,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,disp_scale = binning,/nopause ,beta = beta  ;,/check_lines

endif

pp = 1
if pp eq 1 then begin

inpath = output_dir
outpath = '/data/cbeck/obs2015/obs_egidio_roberto_aug2015/FIRS_archive_temp/190815/'

iinput_dir = input_dir


generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3,wavelen = 589.,pollimit = .01,iinput_dir = iinput_dir,/pp1

inpath = outpath
firs_create_html,filepath = inpath

stop

inpath = '/export/cbeck/FIRS_archive/'
outfile = inpath + 'FIRS_archivemain.html'

firs_create_mainhtml,inpath =inpath,outfile = outfile

endif


stop


end
