pro cal_200413_630


input_dir = '/nfs/export/scr2/cbeck/obs2013/200413/firs1/'
output_dir = '/export/cbeck/obs2013/firs_april2013/200413_reduced_630/'

change_save = '/export/cbeck/obs2013/firs_april2013/200413_reduced_630/' 


;get_firs_dataprop,input_dir,change_save =change_save

; 16 cal   2 map  1 ff 0 dc

; 2012 12 10
types1 = [0,1,2,2,2,2,2,1,0,2,2,1,0,16,16,16]

pp = 0
if pp eq 1 then begin

firs_630_ff,change_save = change_save,flat_file = 1,dark_file = 0,/plt,input_dir = input_dir,output_dir = output_dir,/nopause

firs_630_ff,change_save = change_save,flat_file = 7,dark_file = 8,/plt,input_dir = input_dir,output_dir = output_dir,/nopause

firs_630_ff,change_save = change_save,flat_file = 11,dark_file = 12,/plt,input_dir = input_dir,output_dir = output_dir,/nopause



firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 14,darkindex= 2,gainindex = 2,change_save =change_save,theta_err = 5,retard = 88.,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 15,darkindex= 2,gainindex = 2,change_save =change_save,theta_err = 5,retard = 88.,theta_pol = 45.,/nopause


endif

pp = 1
if pp eq 1 then begin

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 14,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  6,angle = 0,pos_lines = [132.,180.,230.,255.]

stop

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 14,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  10,angle = 0



endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/200413/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2,wavelen = 630.,pollimit = .01;,wwidth = 3

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
