pro cal_211013_1083

; directory to input raw data
input_dir = '/export/cbeck/obs2013/210113/firs/'

; directory for output data
output_dir = '/export/cbeck/obs2013/210113/firs/reduced_210113_1/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save = '/export/cbeck/obs2013/210113/firs/reduced_210113_1/'

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations


; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 21
types1 = [2,2,1,0,2,16,16,1,0,2,2,2]


pp = 1
if pp eq 1 then begin

yyrange = [4,508,512,1015]/2.

; 1 slit, 1083

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

; Attention: bad correlation in one beam. Use keyword /shifts_manual,
; and then answer: rotation: 0 <cr> ; initial value: 0 <cr>; accept: y
; <cr>; shifts x: 2,1,1,0 <cr>; shifts_y: 7,7,7,7 <cr>

firs_1083_ff,change_save = change_save,flat_file = 3,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 7,dark_file = 8,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 10,dark_file = 11,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

; end Attention


firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 4,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,/swap,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 45.,/swap,/nopause

endif


pp = 1
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft2_181013/Tmatrix_May2010_4708-14125.idl'
cal_file = 4
wavelength = 10830.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  9,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  12,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  13,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap

endif

inpath = output_dir
outpath = '/home/cbeck/work/FIRS_archive/2013/211013/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .005

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/home/cbeck/work/FIRS_archive/FIRS_archivemain.html'
 inpath = '/home/cbeck/work/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
