pro cal_230113_1565

; directory to input raw data
input_dir = '/export/cbeck/obs2013/230113/firs/'

; directory for output data
output_dir = '/export/cbeck/obs2013/230113/firs/reduced_230113/'

; change location of save file with data information if you do not have write
; permission in input_dir

; change_save = '/export/cbeck/obs2012/20121209/firs2/' 


pp = 1
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal, observations

;stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 01 23
types1 = [2,2,1,0,2,1,0,16,16,1,0]

pp = 1
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 2,dark_file = 3,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .3,/quit_column,sspeed = .5,/nopause

firs_1083_ff,change_save = change_save,flat_file = 5,dark_file = 6,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .3,/quit_column,sspeed = .5,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 7,darkindex= 1,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 1,change_save =change_save ,theta_err = 5,flat_file = flat_file,theta_pol = 45.,retard = 116.,/quit_column,/nopause

endif


pp = 1
if pp eq 1 then begin

cal_file =  7
tmat_save =  '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  1,tmat_save = tmat_save,wavelength = 15650.,/quit_column,/no_align,offang = 0.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 4,tmat_save = tmat_save,wavelength = 15650.,/quit_column,/no_align,offang = 0.

endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/230113/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1565.,pollimit = .005

inpath = outpath
firs_create_html,filepath = inpath


firs_create_mainhtml


stop


end
