pro cal_281013_1565

; directory to input raw data
input_dir = '/home/cbeck/firs_281013/'

; directory for output data
output_dir = '/home/cbeck/firs_281013_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save = '/home/cbeck/firs_281013_reduced/' 

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations


; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
types1 = [0,1,1,2,1,2,1,2,1,2,2,16,0,1,0,16]


pp = 0
if pp eq 1 then begin

yyrange = [4,508,512,1015]/2.

; 4 slits, 1565

firs_1083_ff,change_save = change_save,flat_file = 2,dark_file = 0,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

; Attention: bad correlation in one beam. Use keyword /shifts_manual,
; and then answer: rotation: 0 <cr> ; initial value: 0 <cr>; accept: y
; <cr>; shifts x: 2,1,1,0 <cr>; shifts_y: 7,7,7,7 <cr>

; end Attention

firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 12,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 12,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 12,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,sshift = [0,-1],/swap,yyrange = yyrange

; no complete calibration on this day

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 7,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/swap,/nopause

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,theta_pol = 45.,/swap,/nopause

endif


pp = 1
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft2_181013/Tmatrix_May2010_4708-14125.idl'
;cal_file = 7
ccal_file = '/home/cbeck/firs_261013_reduced/xmat.firs.2.20131026.130210.sav'

wavelength = 15650.

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 0,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap,/check_lines,ccal_file = ccal_file

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  5,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap,ccal_file = ccal_file,/check_lines

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  7,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap,ccal_file = ccal_file,/check_lines

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  9,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap,ccal_file = ccal_file,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 2,change_save =change_save,obsindex =  10,tmat_save = tmat_save,wavelength = wavelength,/no_align,/quit_column,offang = 0.,/catch_dead,/swap,ccal_file = ccal_file,/check_lines



endif

inpath = output_dir
outpath = '/home/cbeck/work/FIRS_archive/2013/281013/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1565.,pollimit = .005

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/home/cbeck/work/FIRS_archive/FIRS_archivemain.html'
 inpath = '/home/cbeck/work/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
