pro corr_scan

infile = '/data/cbeck/reduced_080813_1/firs.2.20130808.103256.reduced.dat'
restore,infile+'.sav'
tt = size(ic)
a = fltarr(dx_final+1,dy_final+1,4)
erg = associate(infile,a,493)

alpha = -.3

openr,1,infile
for k = 0,tt(1)-1 do begin & readu,1,a & a(*,*,2) = a(*,*,2) - alpha*a(*,*,3) & totu(k,*) =   total(abs(a(295:365,*,2))/a(295:365,*,0),1) & tvscl,alog10(totu) & print,k & endfor
close,1

save,ic,totq,totu,totv,sshifts,llinepos,pos_solar,dx_final,dy_final,n_slits,int_only,ccont_wl,filename = infile+'.sav'



erg(*,*,2) = erg(*,*,2) - alpha*erg(*,*,3)

cchars = 1.5
window,0,xs = 1016,ys = 288*2.
tvscl,congrid(reform(erg(*,*,0)),1016/2.,288,/interp) > 0 < 9000
tvscl,congrid(reform(erg(*,*,1)/erg(*,*,0)),1016/2.,288,/interp) > (-.1) < .1,508,0
tvscl,congrid(reform(erg(*,*,2)/erg(*,*,0)),1016/2.,288,/interp) >(-.1) < .1,0,288
tvscl,congrid(reform(erg(*,*,3)/erg(*,*,0)),1016/2.,288,/interp) >(-.1) < .1,508,288
plots,[0,1016],[0,0]+288,/device,thick = 2
plots,[0,0]+1016/2.,[0,2*288],/device,thick = 2

plots,[0,1016],[0,0]+102,/device,thick = 2,linestyle = 4

plots,[0,1016],[0,0]+102+288,/device,thick = 2,linestyle = 4

xyouts,findgen(2)/2.+.01,.01,['I','Q'],charsize = cchars,/normal
xyouts,findgen(2)/2.+.01,.51,['U','V'],charsize = cchars,/normal

a = tvrd()

write_jpeg,'/export/cbeck/work/FIRS/FIRS_spec_080813.jpg',a


window,0
!p.multi = [4,2,2]
qqq = reform(erg(*,177,0))
for k = 0,15 do begin & qqq(500+k) = qqq(500) & endfor
qqq = smooth(qqq,5)
plot,qqq,title = 'Stokes I',charsize = cchars,xr = [0,1000],/xstyle
qqq = reform(erg(*,177,1)/erg(*,177,0))
for k = 0,15 do begin & qqq(500+k) = qqq(500) & endfor
qqq = smooth(qqq,5)
plot,qqq >(-.1) < .1,title = 'Stokes Q',charsize = cchars,xr = [0,1000],/xstyle
qqq = reform(erg(*,177,2)/erg(*,177,0))
for k = 0,15 do begin & qqq(500+k) = qqq(500) & endfor
qqq = smooth(qqq,5)
plot,qqq>(-.1) < .1,title = 'Stokes U',charsize = cchars,xr = [0,1000],/xstyle
qqq = reform(erg(*,177,3)/erg(*,177,0))
for k = 0,15 do begin & qqq(500+k) = qqq(500) & endfor
qqq = smooth(qqq,5)
plot,qqq >(-.15) < .15,title = 'Stokes V',charsize = cchars,xr = [0,1000],/xstyle


a = tvrd()

write_jpeg,'/export/cbeck/work/FIRS/FIRS_singlespec_080813.jpg',255-a



ic1 = ic
totq1 = totq
totu1 = totu
totv1 = totv


window,1,xs = 1100,ys = 288*2.
tvscl,congrid(ic1,550,480*.18/.3,/interp) > 0 < 8000,0,0
tvscl,congrid(alog10(totq1),550,480*.18/.3,/interp),550,0
tvscl,congrid(alog10(totu1),550,480*.18/.3,/interp),0,288
tvscl,congrid(alog(totv1),550,480*.18/.3,/interp),550,288

plots,[0,0]+1100/2.+493,[0,2*288],/device,thick = 2,linestyle = 2
plots,[0,0]+493,[0,2*288],/device,thick = 2,linestyle = 2

plots,[0,1100],[0,0]+288,/device,thick = 2
plots,[0,0]+1100/2.,[0,2*288],/device,thick = 2

xyouts,findgen(2)/2.+.01,.01,['I','Q'],charsize = cchars,/normal
xyouts,findgen(2)/2.+.01,.51,['U','V'],charsize = cchars,/normal

a = tvrd()
write_jpeg,'/export/cbeck/work/FIRS/FIRS_2d_080813.jpg',a


restore,'/data/cbeck/reduced_080813_1/firs.2.20130808.100525.reduced.dat.sav'
ic2 = ic

window,2,xs = 200,ys = 288
tvscl,congrid(ic2,200,480*.18/.3,/interp) > 0 < 8000,0,0
xyouts,.01,.95,'Target 080813',charsize = cchars ,/normal

a = tvrd()
write_jpeg,'/export/cbeck/work/FIRS/FIRS_target_080813.jpg',a

infile1 = '/data/cbeck/obs2013/160513/reduced_1083_spinor_fringefiltered/130516.090909.0.ccc01.c-hrt.map.0003.fits.reduced.fringe_filtered.dat'
restore,infile1+'.sav'

tt = size(ic)
a = fltarr(dx_final+1,dy_final+1,4)


for k = 0,tt(1)-1 do begin & erg = associate(infile1,a,k) & totq(k,*) =total(abs(a(130:150,*,1))/a(130:150,*,0),1) & totu(k,*) =total(abs(a(130:150,*,2))/a(130:150,*,0),1) & totv(k,*) =total(abs(a(130:150,*,3))/a(130:150,*,0),1) & endfor


ic3 = ic
totq3 = totq
totu3 = totu
totv3 = totv

window,3,xs = 2*360,ys = 2*243
tvscl,ic3 > 30000 <70000,0,0
tvscl,(totq3 >.001),360,0
tvscl,(totu3>.001),0,243
tvscl,(totv3>.001),360,243

plots,[0,720],[0,0]+243,/device,thick = 2
plots,[0,0]+360,[0,2*243],/device,thick = 2

xyouts,findgen(2)/2.+.01,.01,['I','Q'],charsize = cchars,/normal
xyouts,findgen(2)/2.+.01,.51,['U','V'],charsize = cchars,/normal

a = tvrd()
write_jpeg,'/export/cbeck/work/FIRS/SPINOR_2d_160513.jpg',a


a = fltarr(dx_final+1,dy_final+1,4)
erg = associate(infile1,a,170) 


window,4,xs = 1016,ys = 288*2.
tvscl,congrid(reform(erg(*,*,0)),1016/2.,288,/interp) > 50000 < 200000
tvscl,congrid(reform(erg(*,*,1)/erg(*,*,0)),1016/2.,288,/interp) > (-.1) < .1,508,0
iii =congrid(reform( (erg(*,*,2)-200.)/erg(*,*,0)),1016/2.,288,/interp)
iii(0,0) = -.03
iii(0,1) = .03
tvscl,iii >(-.03) < .03,0,288
tvscl,congrid(reform(erg(*,*,3)/erg(*,*,0)),1016/2.,288,/interp) >(-.1) < .1,508,288


plots,[0,1016],[0,0]+288,/device,thick = 2
plots,[0,0]+508,[0,2*288],/device,thick = 2

xyouts,findgen(2)/2.+.01,.01,['I','Q'],charsize = cchars,/normal
xyouts,findgen(2)/2.+.01,.51,['U','V'],charsize = cchars,/normal

a = tvrd()
write_jpeg,'/export/cbeck/work/FIRS/SPINOR_spec_160513.jpg',a



openr,1,infile
for k = 0,tt(1)-1 do begin & readu,1,a & a(*,*,2) = a(*,*,2) - alpha*a(*,*,3) & totu(k,*) =   total(abs(a(295:365,*,2))/a(295:365,*,0),1) & tvscl,alog10(totu) & endfor





end
