pro firs_1083_fringes



input_dir = '/export/cbeck/obs2012/20121212/firs2/'
output_dir = '/export/cbeck/obs2012/20121212/firs2/reduced_20121212/'


erg = read_directory(input_dir,filter ='*.sav')
outfile = erg.files
restore,input_dir+outfile(0)


; 2012 12 12 asc
types1 = [0,1,2,2,1,16,16,1,0,2,2,2,16,16,16,16,1]

;  2012 12 12 asc
;darkbasefile = bbasefile1(0)
darkbasefile = bbasefile1(8)

;  2012 12 12 asc
;flatbasefile = bbasefile1(1)
;flatbasefile = bbasefile1(4)
flatbasefile = bbasefile1(7)


ergdc = read_directory(output_dir,filter ='*dc*')
restore,output_dir + ergdc.files(1)

erggain = read_directory(output_dir,filter ='*gain*')

gainfile = output_dir + erggain.files(2)

restore,gainfile

restore,output_dir+'ff.'+flatbasefile+'sav'


ff_img = ff_img - dc

ww = where(ff_img lt 0)
if ww(0) ne -1 then ff_img(ww) = 1.
ww = where(ff_img eq 0)
if ww(0) ne -1 then ff_img(ww) = 1.


ibeams = fltarr(n_slits,2,dx+1,dy+1,4)

dum = ff_img

for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

  ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

  for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/gaintable(kk,1,*,*,kkk) & endfor & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor

xx = findgen(dx_final + 1)
xx = xx/180.*!pi

n_per = 24.  
weights = fltarr(dx_final+1)+1.

corr = gaintable - gaintable

aout = fltarr(n_slits,2,dy_final+1,4,4)

;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) = erg & endfor & endfor & endfor


for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) &y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a &  for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) = erg & endfor & endfor & endfor


;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)/corr(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [1,1,1,1]) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = corr(k,0,*,kkk,kk)*erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)/corr(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) &y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a &  for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [1,1,1,1]) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) =corr(k,1,*,kkk,kk)* erg & endfor & endfor & endfor


;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(aout(k,0,*,kk,0)) & ii = median(ii,3) & aout(k,0,*,kk,0) = ii &  ii = reform(aout(k,0,*,kk,1)) & ii = median(ii,3) & aout(k,0,*,kk,1) = ii &  ii = reform(aout(k,0,*,kk,2)) & ii = median(ii,3) & aout(k,0,*,kk,2) = ii &  ii = reform(aout(k,0,*,kk,3)) & ii = median(ii,3) & aout(k,0,*,kk,3) = ii &  ii = reform(aout(k,1,*,kk,0)) & ii = median(ii,3) & aout(k,1,*,kk,0) = ii &  ii = reform(aout(k,1,*,kk,1)) & ii = median(ii,3) & aout(k,1,*,kk,1) = ii &  ii = reform(aout(k,1,*,kk,2)) & ii = median(ii,3) & aout(k,1,*,kk,2) = ii &  ii = reform(aout(k,1,*,kk,3)) & ii = median(ii,3) & aout(k,1,*,kk,3) = ii & endfor & endfor
;corr1 = corr - corr
;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & for kkk = 0,dy_final do begin & sin_var,xx,reform(aout(k,0,kkk,kk,*)),f & corr1(k,0,*,kkk,kk) = f & sin_var,xx,reform(aout(k,1,kkk,kk,*)),f & corr1(k,1,*,kkk,kk) = f  & endfor & endfor & endfor

fringe_corr = corr

save,fringe_corr,aangle,dx,dy,dx_final,dy_final,posx,posy,posx_final,posy_final,gaintable,gaintablecoarse,cchi,n_slits,pposref,mean_slits,mean_slitscoarse,mean_slits1,filename = gainfile

stop

ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/gaintable(kk,1,*,*,kkk) & endfor & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor


for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/fringe_corr(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/fringe_corr(kk,1,*,*,kkk) & endfor & endfor




end
