pro firs_cal,spat_res =spat_res ,no_av = no_av,plt =plt,ilimit = ilimit,retard = retard,theta_err = theta_err,theta_pol = theta_pol,gainindex = gainindex,darkindex = darkindex,cal_file = cal_file,change_save = change_save,input_dir = input_dir,output_dir = output_dir,flat_file = flat_file,swap = swap,add_cal = add_cal,nverbose = nverbose,cchi = cchi



if n_elements(darkindex) eq 0 then  darkindex = 0
if n_elements(cal_file) eq 0 then  cal_file = 0
if n_elements(gainindex) eq 0 then gainindex = 0


if n_elements(ilimit) eq 0 then ilimit = .2
if n_elements(retard) eq 0 then retard = 90.
if n_elements(theta_err) eq 0 then theta_err = 0.
if n_elements(theta_pol) eq 0 then theta_pol = 0.

; sanka
;output_dir = '/export/cbeck/FIRS_data/sankar20120625/reduced_20120625/'
;input_dir = '/export/cbeck/FIRS_data/sankar20120625/'


; ali
;input_dir = '/export/cbeck/FIRS_data/ali20100205/firs1/'
;output_dir = '/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/'


;input_dir = '/export/cbeck/FIRS_data/ali20100202/firs1/'
;output_dir = '/export/cbeck/FIRS_data/ali20100202/firs1/reduced_20100205/'

;input_dir = '/export/cbeck/obs2012/20121212/firs2/'
;output_dir = '/export/cbeck/obs2012/20121212/firs2/reduced_20121212/'


;input_dir = '/export/cbeck/obs2013/190113/firs/'
;output_dir = '/export/cbeck/obs2013/190113/firs/reduced_190113/'


;input_dir = '/export/cbeck/obs2013/200113/firs/'
;output_dir = '/export/cbeck/obs2013/200113/firs/reduced_200113/'


;input_dir = '/export/cbeck/obs2013/210113/firs/'
;output_dir = '/export/cbeck/obs2013/210113/firs/reduced_210113/'

;input_dir = '/export/cbeck/obs2013/220113/firs/'
;output_dir = '/export/cbeck/obs2013/220113/firs/reduced_220113/'

;input_dir = '/export/cbeck/obs2013/230113/firs/'
;output_dir = '/export/cbeck/obs2013/230113/firs/reduced_230113/'

;input_dir = '/export/cbeck/obs2012/20121212/firs1/'
;output_dir = '/export/cbeck/obs2012/20121212/firs1/reduced_20121212/'

;input_dir = '/data/scriscuo/T962/13_dec_2012/coconut/'
;output_dir = '/export/cbeck/obs2012/20121213/firs2/reduced_131212/'

;input_dir = '/data/scriscuo/T962/13_dec_2012/papaya/'
;output_dir = '/export/cbeck/obs2012/20121213/firs1/reduced_131212/'


;input_dir = '/data/scriscuo/T962/11_dec_2012/coconut/'
;output_dir = '/export/cbeck/obs2012/20121211/firs2/reduced_111212/'


erg = read_directory(input_dir,filter ='*.sav')
if n_elements(change_save) ne 0 then erg = read_directory(change_save,filter ='*.sav')

outfile = erg.files
if n_elements(change_save) eq 0 then restore,input_dir+outfile(0) else restore,change_save+outfile(0)


; sanka
types1 = [2,1,2,1,16,16,16,0]


; 2010 02 05 ali
types1 = [16,1,0,2,2]

; 2010 02 02 ali
types1 = [2,2,2,2,2,2,2,2,16,1,1,0]


; 2012 12 12 asc
types1 = [0,1,2,2,1,16,16,1,0,2,2,2,16,16,16,16,1]


; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
types1 = [2,2,1,0,2,0,2,2,16,16,0]

; 2013 01 20
types1 = [2,1,0,2,2,1,0,2,1,0,2,16,16,2,2,1,0]

; 2013 01 21
types1 = [2,2,1,0,2,16,16,1,0,16,16,16]

; 2013 01 22
types1 = [2,1,0,2,0,2,2,2,1,0,16,16,1,0]

; 2012 12 13
types1 = [2,2,1,2,1,16,16,1,0,0,2,2,2,1,1,0,0]


ergdc = read_directory(output_dir,filter ='*dc*')
restore,output_dir + ergdc.files(darkindex)

if n_elements(flat_file) eq 0 then begin
   erggain = read_directory(output_dir,filter ='*gain*')
   restore,output_dir + erggain.files(gainindex)
endif else begin

   restore,flat_file

endelse



; calibration data

calbasefile = bbasefile1(cal_file)
erg = read_directory(input_dir,filter =calbasefile+'*')
calfiles = erg.files(where(erg.types eq 0))
n = float(n_elements(calfiles))

outfile = output_dir+'polvec.'+calbasefile+'sav'
outfile1 = output_dir+'xmat.'+calbasefile+'sav'

if n_elements(plt) ne 0 then begin

window,0,title ='Calibration measurements'
laodct,41
device,decomposed = 0

endif


if n_elements(no_av) eq 0 then begin

   print,' Reading in calibration  files...',calbasefile

   fxread,input_dir+calfiles(0),dum,hdr
   cal_img = dum -dum
   tt = size(dum)

   if n_elements(spat_res) eq 0 then cal_curves = fltarr(n_slits,n,4) else begin
      
      xx = floor(dx_final/float(spat_res(0)))
      yy = floor(dy_final/float(spat_res(1)))

      xxr = findgen(dx_final/xx)*xx
      yyr = findgen(dy_final/yy)*yy

      cal_curves = fltarr(n_slits,n,n_elements(xxr),n_elements(yyr),4)

      xxr = [xxr,dx_final]
      yyr = [yyr,dy_final]

   endelse


   


   for k = 0,n-1 do begin
      fxread,input_dir+calfiles(k),dum,hdr
      if n_elements(swap) ne 0 then dum = swap_endian(dum)
      dum = dum -dc
  
; obsolete
 ;getiquv,dum,ii,qq,uu,vv
 

      ibeams = fltarr(n_slits,2,dx+1,dy+1,4)

for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

;  for kk = 0,n_slits-1 do begin &  ii_temp = rot(reform(dum(*,*,0)),aangle(kk),/interp) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = rot(reform(dum(*,*,1)),aangle(kk),/interp) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = rot(reform(dum(*,*,2)),aangle(kk),/interp) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = rot(reform(dum(*,*,3)),aangle(kk),/interp) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

     ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

  for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor


     ibeams_merged =  fltarr(n_slits,dx_final+1,dy_final+1,4)
  for kk = 0,n_slits -1 do begin & for kkk = 0,3 do begin & ibeams_merged(kk,*,*,kkk) =    ( ibeams1(kk,0,*,*,kkk) - ibeams1(kk,1,*,*,kkk) ) / (ibeams1(kk,0,*,*,kkk) + ibeams1(kk,1,*,*,kkk) )& endfor & endfor
; obsolete if kkk eq 0 then  ibeams_merged(kk,*,*,kkk) =    0.5*(
; ibeams1(kk,0,*,*,kkk) + ibeams1(kk,1,*,*,kkk) ) else 

   if n_elements(spat_res) eq 0 then begin
   for kk = 0,n_slits-1 do begin  & temp_i = reform(ibeams_merged(kk,*,*,0))  & temp_q = reform(ibeams_merged(kk,*,*,1)) & temp_u = reform(ibeams_merged(kk,*,*,2)) & temp_v = reform(ibeams_merged(kk,*,*,3))& ttemp_i = reform(ibeams1(kk,0,*,*,0)) & ff = where(ttemp_i gt ilimit*max(ttemp_i)) & cal_curves(kk,k,0) = mean(temp_i(ff)) & cal_curves(kk,k,1) = mean(temp_q(ff)) & cal_curves(kk,k,2) = mean(temp_u(ff)) & cal_curves(kk,k,3) = mean(temp_v(ff)) & endfor

   endif else begin

; ff = where(temp_i gt ilimit*max(temp_i)) & temp_q = temp_q/ temp_i& temp_u = temp_u/ temp_i& temp_v = temp_v/ temp_i & 

; cal_curves(kk,k,1) = mean(ibeams_merged(kk,*,*,1)/ibeams_merged(kk,*,*,0)) &  cal_curves(kk,k,2) = mean(ibeams_merged(kk,*,*,2)/ibeams_merged(kk,*,*,0)) &  cal_curves(kk,k,3) = mean(ibeams_merged(kk,*,*,3)/ibeams_merged(kk,*,*,0))& endfor
;   endif else begin

      for kk = 0,n_slits-1 do begin 

         for kkk = 0,n_elements(xxr)-2 do begin 
            for kkkk = 0,n_elements(yyr)-2 do begin 
               cal_curves(kk,k,kkk,kkkk,0) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,1) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),1)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,2) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),2)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,3) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),3)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0))

            endfor
         endfor


      endfor


   endelse

if n_elements(plt) ne 0 then begin

   if n_elements(spat_res) eq 0 then begin

      erase
      !p.multi = [4,2,2]
      plot,cal_curves(0,*,0)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,0),color =40*kk & endfor
      
      plot,cal_curves(0,*,1)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,1),color =40*kk & endfor
      
      plot,cal_curves(0,*,2)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,2),color =40*kk & endfor
      plot,cal_curves(0,*,3)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,3),color =40*kk & endfor
      wait,.1

   endif else begin

      erase
      !p.multi = [4,2,2]
      plot,cal_curves(0,*,0,0,0)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,0),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor

 plot,cal_curves(0,*,0,0,1)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,1),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor
plot,cal_curves(0,*,0,0,2)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,2),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor

plot,cal_curves(0,*,0,0,3)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,3),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor

   endelse
endif



endfor

if n_elements(add_cal) ne 0 then begin

   print
   print,'Reading in additional calibration files...'
   add_calfiles = bbasefile1(add_cal)
   
for k = 0,n_elements(add_calfiles) -1 do begin & erg = read_directory(input_dir,filter = add_calfiles(k)+'*') & add_calfiles(k) = erg.files(0) & endfor



   add_calvalues = fltarr(n_slits,4,4,2)

 for k = 0,3 do begin
      fxread,input_dir+add_calfiles(k),dum,hdr
      if n_elements(swap) ne 0 then dum = swap_endian(dum)
      dum = dum -dc
   
      ibeams = fltarr(n_slits,2,dx+1,dy+1,4)

for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

     ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

  for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor


 ;ibeams_merged =  fltarr(n_slits,dx_final+1,dy_final+1,4)
 ;    for kk = 0,n_slits -1 do begin & for kkk = 0,3 do begin & ibeams_merged(kk,*,*,kkk) =    ( ibeams1(kk,0,*,*,kkk) - ibeams1(kk,1,*,*,kkk) ) / (ibeams1(kk,0,*,*,kkk) + ibeams1(kk,1,*,*,kkk) )& endfor & endfor

   if n_elements(spat_res) eq 0 then begin

      for kk = 0,n_slits-1 do begin  & temp_i = reform(ibeams1(kk,0,*,*,0))  & temp_q = reform(ibeams1(kk,0,*,*,1))  & temp_u = reform(ibeams1(kk,0,*,*,2))  & temp_v = reform(ibeams1(kk,0,*,*,3)) &  ff = where(ttemp_i gt ilimit*max(ttemp_i)) &  add_calvalues(kk,k,*,0) = [mean( temp_i(ff)),mean( temp_q(ff)),mean( temp_u(ff)),mean( temp_v(ff))] & temp_i = reform(ibeams1(kk,1,*,*,0))  & temp_q = reform(ibeams1(kk,1,*,*,1))  & temp_u = reform(ibeams1(kk,1,*,*,2))  & temp_v = reform(ibeams1(kk,1,*,*,3)) &  ff = where(ttemp_i gt ilimit*max(ttemp_i)) &  add_calvalues(kk,k,*,1) = [mean( temp_i(ff)),mean( temp_q(ff)),mean( temp_u(ff)),mean( temp_v(ff))] & endfor



   endif else begin
    ;  for kk = 0,n_slits-1 do begin 

     ;    for kkk = 0,n_elements(xxr)-2 do begin 
      ;      for kkkk = 0,n_elements(yyr)-2 do begin 
       ;        cal_curves(kk,k,kkk,kkkk,0) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,1) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),1)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,2) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),2)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0)) &  cal_curves(kk,k,kkk,kkkk,3) = mean(ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),3)/ibeams_merged(kk,xxr(kkk):xxr(kkk+1),yyr(kkkk):yyr(kkkk+1),0))

        ;    endfor
        ; endfor


;   endfor

  endelse

endfor


endif


if n_elements(add_cal) eq 0 then save,cal_curves,filename = outfile else  save,cal_curves,add_calvalues,filename = outfile

endif

; get saved polarization vectors
restore,outfile

if n_elements(plt) ne 0 then begin
   window,0,title ='Polarization degree in '+num2string(n_slits)+' slits'
   !p.multi = [n_slits,1,n_slits]
for k = 0,n_slits-1 do begin & plot,sqrt( (cal_curves(k,*,1))^2.+ (cal_curves(k,*,2))^2.+ (cal_curves(k,*,3))^2.) & endfor
endif


; create input polarization 



; Calculate Stokes input from calibration unit

; Non-ideal polarizer
; calculation of dichroism
px = 1.
py = 0.005
sq = sqrt(px*py)
a = ( px + py )/2.
c = ( px - py )/2.
polmat = setmtxright(a,c,0,0,c,a,0,0,0,0,0,0,0,0,0,0)/( (px + py )/2.)

; Retardance of cal. unit of the observation wavelength
; Non-ideal waveplate

; Offset angle between POL and RET (presently not used)


; retardance
retard = retard*!pi/180.

; Non-ideal retarder
b = 0.

; calculation of dichroism
px = 1 + b/2.
py = 1 - b/2.

sq = sqrt(px*py)
a = ( px + py )/2.
c = ( px - py )/2.
retmat = setmtxright(a,c,0,0,c,a,0,0,0,0,sq*cos(retard),sq*sin(retard),0,0,-sq*sin(retard),sq*cos(retard))

theta_err = theta_err*!pi/180.

stokesin = fltarr(n,4)
; calculate Stokes vector
for t =0,n-1 do begin

       ; thetaret = (-55.+t*5.)*!pi/180.

        thetaret = (0+t*10.)*!pi/180.

        thetapol = theta_pol*!pi/180.

; rotation of polarizer
        c = cos(2*thetapol)
        s = sin(2*thetapol)
        rotext1 = setmtxright(1,0,0,0,0,c,s,0,0,-s,c,0,0,0,0,1)
        rotext2 = setmtxright(1,0,0,0,0,c,-s,0,0,s,c,0,0,0,0,1)

; rotation of retarder
        c1 = cos(2*thetaret)
        s1 = sin(2*thetaret)
        rotint1 = setmtxright(1,0,0,0,0,c1,s1,0,0,-s1,c1,0,0,0,0,1)
        rotint2 = setmtxright(1,0,0,0,0,c1,-s1,0,0,s1,c1,0,0,0,0,1)

; rotation between both elements     
        c2 = cos(2*theta_err)
        s2 = sin(2*theta_err)
        rot_err = setmtxright(1,0,0,0,0,c2,s2,0,0,-s2,c2,0,0,0,0,1)

; calculate optical train
        calibmat = rotint2 ## retmat ## rotint1 ## rot_err ## rotext2 ## polmat ## rotext1

stokesvec = (calibmat ## [1,0,0,0])
stokesvec =  stokesvec/stokesvec(0)

stokesin(t,*) = stokesvec
endfor



if n_elements(plt) ne 0 then begin

   if n_elements(spat_res) eq 0 then begin

      erase
      !p.multi = [4,2,2]
      plot,cal_curves(0,*,0)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,0),color =40*kk & endfor
   ;   oplot,stokesin(*,0),color = 240,thick = 2,linestyle = 3

      plot,cal_curves(0,*,1)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,1),color =40*kk & endfor
   ;   oplot,stokesin(*,1),color = 240,thick = 2,linestyle = 3
      
      plot,cal_curves(0,*,2)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,2),color =40*kk & endfor
    ;  oplot,stokesin(*,2),color = 240,thick = 2,linestyle = 3

      plot,cal_curves(0,*,3)
   for kk = 1,n_slits-1 do begin  oplot,cal_curves(kk,*,3),color =40*kk & endfor
    ;  oplot,stokesin(*,3),color = 240,thick = 2,linestyle = 3
   endif else begin

      erase
      !p.multi = [4,2,2]
      plot,cal_curves(0,*,0,0,0)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,0),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor
    ;  oplot,stokesvin(*,0),color = 240,thick = 2,linestyle = 3

      plot,cal_curves(0,*,0,0,1)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,1),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor
    ;  oplot,stokesvin(*,1),color = 240,thick = 2,linestyle = 3
      
      plot,cal_curves(0,*,0,0,2)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,2),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor
    ;  oplot,stokesvin(*,2),color = 240,thick = 2,linestyle = 3

      plot,cal_curves(0,*,0,0,3)
   for kk = 1,n_slits-1 do begin & for kkk = 0,n_elements(xxr)-2 do begin & for kkkk = 0,n_elements(yyr)-2 do begin oplot,cal_curves(kk,*,kkk,kkkk,3),color =10*(kk+kkk+kkkk) & endfor & endfor & endfor
    ;  oplot,stokesvin(*,3),color = 240,thick = 2,linestyle = 3
   endelse

; obsolete for k = 0,n_slits -1 do begin &   ii = reform(cal_curves(k,*,0)) & erg = analytger(findgen(n_elements(ii)),ii)& yy = erg(1)+erg(0)*findgen(n_elements(ii)) &  ii = ii / yy & cal_curves(k,*,0) = ii & endfor


endif



xxmat = fltarr(n_slits,4,4)

if n_elements(add_cal) ne 0 then cchi = fltarr(4)

for k = 0,n_slits -1 do begin
   
   stokesout = reform(cal_curves(k,*,*))
   

; do matrix inversion between input and output
matrix_inversion,transpose(stokesin),transpose(stokesout),xmat,error

;x00 =  xmat(0,0)
;xmat = xmat / xmat(0,0)

xxmat(k,*,*) = xmat

xinitial = xmat

xmat(0,*) = xmat(0,*)+1
normaliza=max(xmat(0,*))
xmat(0,*)=xmat(0,*)/normaliza
for i=1,3 do begin xmat(i,*)=xmat(i,*)*xmat(0,*) & endfor


if n_elements(add_cal) ne 0 then begin

   dmod=invert(xmat,/double)
   dmod = transpose(dmod)
 
for i=0,3 do begin & dmod(*,i)=dmod(*,i)*xmat(i,0) & endfor
   dmod = transpose(dmod)

;   add_calvalues = fltarr(n_slits,4,4,2)

add_stokesout = fltarr(4,4)


; demodulate addcal values
for i = 0,3 do begin 
   im1a = reform(add_calvalues(k,i,0,0))
   im2a = reform(add_calvalues(k,i,1,0))
   im3a = reform(add_calvalues(k,i,2,0))
   im4a = reform(add_calvalues(k,i,3,0))

   im1b = reform(add_calvalues(k,i,0,1))
   im2b = reform(add_calvalues(k,i,1,1))
   im3b = reform(add_calvalues(k,i,2,1))
   im4b = reform(add_calvalues(k,i,3,1))

   i1a  = dmod(0,0)*im1a+dmod(1,0)*im2a+dmod(2,0)*im3a+dmod(3,0)*im4a
   i2a  = dmod(0,1)*im1a+dmod(1,1)*im2a+dmod(2,1)*im3a+dmod(3,1)*im4a
   i3a  = dmod(0,2)*im1a+dmod(1,2)*im2a+dmod(2,2)*im3a+dmod(3,2)*im4a
   i4a  = dmod(0,3)*im1a+dmod(1,3)*im2a+dmod(2,3)*im3a+dmod(3,3)*im4a
   
   i1b  = dmod(0,0)*im1b+dmod(1,0)*im2b+dmod(2,0)*im3b+dmod(3,0)*im4b
   i2b  = dmod(0,1)*im1b+dmod(1,1)*im2b+dmod(2,1)*im3b+dmod(3,1)*im4b
   i3b  = dmod(0,2)*im1b+dmod(1,2)*im2b+dmod(2,2)*im3b+dmod(3,2)*im4b
   i4b  = dmod(0,3)*im1b+dmod(1,3)*im2b+dmod(2,3)*im3b+dmod(3,3)*im4b

   ii1 = (i1a+i1b)/2.
   qq1 = (i2a-i2b)/2.
   uu1 = (i3a-i3b)/2.
   vv1 = (i4a-i4b)/2.

   add_stokesout(i,*) = [ii1,qq1,uu1,vv1]

endfor

for i = 0,3 do begin & add_stokesout(i,*) = add_stokesout(i,*)/add_stokesout(i,0) & endfor

chi = total(  (add_stokesout(0,*) - [1,1,0,0])^2. +  (add_stokesout(1,*) - [1,0,1,0])^2. + (add_stokesout(2,*) - [1,-1,0,0])^2. + (add_stokesout(3,*) - [1,0,-1,0])^2. )

cchi(k) = chi

if n_elements(nverbose) eq 0 then begin
print
print,' Output - Input add cal'
print,transpose(add_stokesout(0,*)),[1,1,0,0]
print,transpose(add_stokesout(1,*)),[1,0,1,0]
print,transpose(add_stokesout(2,*)),[1,-1,0,0]
print,transpose(add_stokesout(3,*)),[1,0,-1,0]
print
print,'Average deviation of add_cal vectors: ',sqrt(chi)/4.

endif


endif






; invert (forward) response
xinv = invert(xinitial,/double)

if n_elements(nverbose) eq 0 then begin

print
print,'Xmat: '
print,xmat
xmat = transpose(xmat)
print
;rr = check_physicality(xmat)
;if rr(0) le 0 then print,' !! firs_630_cal: Warning !! Unphysical X matrix.'
;if rr(0) ge 0 then print,' firs_630_cal: X matrix seems to be ok...'
print
print,'Inverse'
print,xinv
print
print,'Efficiencies:'
print,effic(xmat),format='(5f8.3)'
endif
erg = effic(xmat)
if n_elements(nverbose) eq 0 then print,' '


if max(erg(1:3)) gt 0.866 then begin
   print
   print,' !! firs_630_cal: Warning !! Efficiencies above maximal possible value of 0.866.' 
print
endif

if n_elements(plt) ne 0 then begin


totout = stokesout

ii1  = xinv(0,0)*stokesout(*,0)+xinv(1,0)*stokesout(*,1)+xinv(2,0)*stokesout(*,2)+xinv(3,0)*stokesout(*,3)
ii2  = xinv(0,1)*stokesout(*,0)+xinv(1,1)*stokesout(*,1)+xinv(2,1)*stokesout(*,2)+xinv(3,1)*stokesout(*,3)
ii3  = xinv(0,2)*stokesout(*,0)+xinv(1,2)*stokesout(*,1)+xinv(2,2)*stokesout(*,2)+xinv(3,2)*stokesout(*,3)
ii4  = xinv(0,3)*stokesout(*,0)+xinv(1,3)*stokesout(*,1)+xinv(2,3)*stokesout(*,2)+xinv(3,3)*stokesout(*,3)

i1 = xinitial(0,0)*stokesin(*,0)+xinitial(1,0)*stokesin(*,1)+xinitial(2,0)*stokesin(*,2)+xinitial(3,0)*stokesin(*,3)
i2 = xinitial(0,1)*stokesin(*,0)+xinitial(1,1)*stokesin(*,1)+xinitial(2,1)*stokesin(*,2)+xinitial(3,1)*stokesin(*,3)
i3 = xinitial(0,2)*stokesin(*,0)+xinitial(1,2)*stokesin(*,1)+xinitial(2,2)*stokesin(*,2)+xinitial(3,2)*stokesin(*,3)
i4 = xinitial(0,3)*stokesin(*,0)+xinitial(1,3)*stokesin(*,1)+xinitial(2,3)*stokesin(*,2)+xinitial(3,3)*stokesin(*,3)

window,0,title = 'Observed output, slit '+num2string(k+1)
!p.multi = [4,1,4]
plot,stokesout(*,0),/yno
oplot,i1,psym = -1,color = 240
plot,stokesout(*,1),/yno
oplot,i2,psym = -1,color = 240
plot,stokesout(*,2),/yno
oplot,i3,psym = -1,color = 240
plot,stokesout(*,3),/yno
oplot,i4,psym = -1,color = 240

window,1,title = 'Created input, slit '+num2string(k+1)
!p.multi = [4,1,4]
plot,stokesin(*,0),/yno,yrange = [.9,1.1],/ystyle
oplot,ii1,psym = -1,color = 240
plot,stokesin(*,1),/yno
oplot,ii2,psym = -1,color = 240
plot,stokesin(*,2),/yno
oplot,ii3,psym = -1,color = 240
plot,stokesin(*,3),/yno
oplot,ii4,psym = -1,color = 240

paused


endif


endfor



if n_elements(nverbose) eq 0 then print,'Saving to: ',outfile1

if n_elements(add_cal) eq 0 then save,theta_err,xxmat,retard,filename = outfile1 else save,theta_err,xxmat,retard,cchi,add_stokesout,filename = outfile1

if n_elements(add_cal) ne 0 then begin
   print
   print,total(cchi/4.),retard/!pi*180.
endif

end

