pro paused,notext = notext

;+
;============================================================================
;
; procedure : paused
;
; purpose   : stop until user confirms with return
;
; calls     : read_keyboard.pro
;
; keyword   : \notext : do not print standard text 'Paused. Hit return
;                       to continue.'
;
; written   : cbeck@KIS 06/02
;
;============================================================================
;-

if n_elements(notext) ne 0 then ans = read_keyboard() else ans = read_keyboard('Paused. Hit return to continue.')

end
