pro cal_030516_1083

; directory to input raw data
input_dir = '/net/koa/export/data/cbeck/obs2016/t1074/03_may_2016/'

; directory for output data
output_dir = '/net/koa/export/data/cbeck/obs2016/t1074/030516_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/net/koa/export/data/cbeck/obs2016/t1074/030516_reduced/'

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations

 
; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
;types1 = [2,1,0,2,1,0,16,16,1,0]

pp = 1
if pp eq 1 then begin

yyrange = [10,495,530,1015]/2.

;yyrange = [0,495,515,1005]/2. 

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1  ,/pickx,/no_av ;,/check_lines

firs_1083_ff,change_save = change_save,flat_file = 3,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1 ,/pickx,/no_av ;,/check_lines

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1 ,/pickx, /no_av;,/check_lines


firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 0,gainindex = 2,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 0.,/nopause ;,n_separations = 5

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 10,darkindex= 0,gainindex = 2,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 45.,/nopause ;,n_separations = 5

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 12,darkindex= 2,gainindex = 2,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 0.,/nopause ;,n_separations = 5

endif


pp = 1
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'
wavelength = 15650. ;0830.

;cont_wl = [90,110]
;pos_lines = [62,139]

cal_file = 8

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause ;,/no_align

cal_file = 12

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  5,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause ;,/no_align

endif


inpath = output_dir
outpath = '/export/raid2/cbeck/work/FIRS_archive/2016/020516/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3.,wavelen = 1565.,pollimit = .01,iinput_dir = iinput_dir

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/export/raid2/cbeck/work/FIRS_archive/FIRS_archivemain.html'
inpath = '/export/raid2/cbeck/work/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
