pro cal_030915_1083


; directory to input raw data
input_dir = '/data/cbeck/obs2015/obs_yukio_aug_2015/FIRS_030915/'

; directory for output data
output_dir = '/data/cbeck/obs2015/obs_yukio_aug_2015/FIRS_030915_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save = '/data/cbeck/obs2015/obs_yukio_aug_2015/FIRS_030915_reduced/'


pp = 0
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations, edit the rest below correspondingly

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2014 03 22
;types1 = [1,0,2,1,0,2,2,1,0,2,2,16,16,1,0]

pp = 0
if pp eq 1 then begin

yyrange = [0,495,515,1005]/2. 

sshift = [0,-10]

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .05,/quit_column,sspeed = .5,/swap,yyrange = yyrange,sshift = sshift,/lamp,/no_av

sshift = [0,0]

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,/swap,yyrange = yyrange,sshift = sshift,/avdc_only

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 3,flat_file = flat_file,retard = 83.,/quit_column,/swap ;,/no_av

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 13,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 3,flat_file = flat_file,retard = 83.,/quit_column,/swap

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 3,darkindex= 0,gainindex = 0,change_save =change_save,theta_err = 3,flat_file = flat_file,retard = 83.,/quit_column,/nopause,theta_pol = 45.,/swap


;stop


endif


pp = 1
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

cal_file = 0
ccal_file = '/data/cbeck/obs2015/obs_yukio_aug_2015/FIRS_020915_reduced/xmat.firs.2.20150902.132040.sav'

cont_wl = [290,310]
pos_lines = [344,426]

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 5,tmat_save = tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl,/nopause,/check_hairlines


endif


pp = 1
if pp eq 1 then begin

inpath = output_dir
outpath = '/data/cbeck/obs2015/obs_yukio_aug_2015/FIRS_archive_temp/030915/'

;export/cbeck/FIRS_archive/2015/210215/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3,wavelen = 1083.,pollimit = .01,iinput_dir = iinput_dir 

inpath = outpath
firs_create_html,filepath = inpath

stop

inpath = '/export/cbeck/FIRS_archive/'
outfile = inpath + 'FIRS_archivemain.html'

firs_create_mainhtml,inpath =inpath,outfile = outfile

endif


stop


end
