pro cal_070213_1565


;spawn,'mkdir /export/cbeck/obs2013/070213/'
;spawn,'mkdir /export/cbeck/obs2013/070213/reduced_070213/'

input_dir = '/net/secchi/export/data/dstservice/rawdata/07_feb_2013/coconut/'

output_dir = '/export/cbeck/obs2013/070213/reduced_070213/'
change_save = '/export/cbeck/obs2013/070213/'

get_firs_dataprop,input_dir,change_save =change_save


; 16 cal   2 map  1 ff 0 dc

; 2013 02 07
types1 = [2,2,2,2,2,0,1,16,16,2,2,2]

pp = 1
if pp eq 1 then begin

; ! Important: for the spatial alignment of the two beams, type
; Accept: "n <cr>", initial value: "7 <cr>". All shifts should be "16"
; in the end.
; ! Important !

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 5,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .5,/quit_column,sspeed = .5

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 7,darkindex= 0,gainindex = 0,theta_err = 5,add_cal = add_cal,ilimit = .7,change_save = change_save,retard = 116.,/quit_column,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 0,gainindex = 0,theta_err = 5,add_cal = add_cal,ilimit = .7,change_save = change_save,retard = 116.,theta_pol = 45.,/quit_column,/nopause


endif

pp = 1
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'
cal_file = 7

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  4,wavelength = 15650.,tmat_save = tmat_save,/quit_column,/no_align,offang = 0.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file =  cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  10,wavelength = 15650.,tmat_save = tmat_save,/quit_column,/no_align,offang = 0.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file =  cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  11,wavelength = 15650.,tmat_save = tmat_save,/quit_column,/no_align,offang = 0.



endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/070213/'

;spawn,'mkdir /export/cbeck/FIRS_archive/2013/070213/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 15650.,pollimit = .003

inpath = outpath
firs_create_html,filepath = inpath


firs_create_mainhtml



stop


end
