pro cal_091013_1083

input_dir = '/nfs/export/scr2/lvtt/firs_10830/'
output_dir = '/data/cbeck/reduced_091013/'
change_save = '/data/cbeck/reduced_091013/'

;get_firs_dataprop,input_dir,change_save =change_save



; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 10 09
types1 = [1,0,16,16,2]

pp = 0
if pp eq 1 then begin

; 4.00000      134.000      142.000      247.000      277.000
; 370.000      402.000      491.000

yyrange = [8,500,526,1018]/2.

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,sshift = [0,-2]

;firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 2,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5

;firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5

;firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 10,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,/avdc_only

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 2,darkindex= 0,gainindex = 0,change_save =change_save, retard = 83.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,/no_av,/nopause
 
;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 3,darkindex= 0,gainindex = 0,change_save =change_save, retard = 83.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,theta_pol = 45.,/no_av,/nopause


endif

pp = 1
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'
cal_file  = 2



firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  4,tmat_save = tmat_save,wavelength = 10830.,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,smooth_width = 3,angle = -.35


endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/091013/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .001

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
