pro cal_091013_1565

input_dir = '/data/smocycle2/09_october_2013/coconut/'
output_dir = '/data/cbeck/091013/'
change_save = '/data/cbeck/091013/'

;get_firs_dataprop,input_dir,change_save =change_save



; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 10 09
types1 = [1,0,2,2,1,0,16,16,0,1,1,1,0,16,16,16,16,2]

pp = 0
if pp eq 1 then begin

; 4 slits, 1565 nm

yyrange = [8,500,526,1018]/2.

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,sshift = [0,-1]

firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 5,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,sshift = [0,-1]

; single slit, 1083 nm, test data set

firs_1083_ff,change_save = change_save,flat_file = 11,dark_file = 12,/plt ,input_dir =input_dir, output_dir = output_dir,/swap,yyrange = yyrange,/pickx,/quit_column,sspeed =  .5,sshift = [0,-1]

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 6,darkindex= 1,gainindex = 1,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,/nopause
 
firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 7,darkindex= 1,gainindex = 1,change_save =change_save, retard = 116.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,theta_pol = 45.,/nopause

; change of wavelength in FIRS, test data set at 1083 nm

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 14,darkindex= 2,gainindex = 2,change_save =change_save, retard = 83.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,/nopause
 
firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 15,darkindex= 2,gainindex = 2,change_save =change_save, retard = 83.,/swap,n_separations = 10.,/quit_column,theta_err = 3.,theta_pol = 45.,/nopause

endif

pp = 0
if pp eq 1 then begin


tmat_save = '/home/cbeck/firs_soft/Tmatrix_May2010_4708-14125.idl'
cal_file  = 6
wavelength = 15650.


firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = wavelength,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/check_lines,/no_align

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = wavelength,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/check_lines,/no_align

cal_file  = 14
wavelength = 10830.

firs_1565_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  16,tmat_save = tmat_save,wavelength = wavelength,angle = .0,/swap,offang = 0.,/quit_column,pos_lines = pos_lines,/catch_dead,/check_lines,/no_align


endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/091013/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1565.,pollimit = .001

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
