pro cal_140316_1565

; directory to input raw data
input_dir = '/media/cbeck/741af552-cd43-4ee7-b250-bc2d2685eada/t1071/14_march_2016/firs_15648/'

; directory for output data
output_dir = '/media/cbeck/741af552-cd43-4ee7-b250-bc2d2685eada/t1071/14_march_2016/FIRS_reduced_140316/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/media/cbeck/741af552-cd43-4ee7-b250-bc2d2685eada/t1071/14_march_2016/FIRS_reduced_140316/'

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations

 
; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
;types1 = [2,1,0,2,1,0,16,16,1,0]

pp = 0
if pp eq 1 then begin

yyrange = [15,490,515,987]/2.

;yyrange = [0,495,515,1005]/2. 

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 0,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange

firs_1083_ff,change_save = change_save,flat_file = 12,dark_file = 11,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 4,darkindex= 1,gainindex = 1,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/nopause

 ;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,theta_pol = 45.,/nopause

endif


pp = 0
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'
wavelength = 15650.

;ccal_file = '/media/cbeck/741af552-cd43-4ee7-b250-bc2d2685eada/t1071/10_march_2016/FIRS_reduced_100316/xmat.firs.2.20160310.151015.sav'


cont_wl = [620,650]
pos_lines = [808,885]


cal_file = 4

for k = 2,3 do begin & firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  k,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause & endfor

for k = 6,6 do begin & firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  k,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause & endfor

for k = 10,10 do begin & firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  k,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause & endfor


endif


inpath = output_dir
outpath = '/export/raid2/cbeck/work/FIRS_archive/2016/140316/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3.,wavelen = 1565.,pollimit = .004,iinput_dir = iinput_dir

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/export/raid2/cbeck/work/FIRS_archive/FIRS_archivemain.html'
inpath = '/export/raid2/cbeck/work/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
