pro cal_180413_630


input_dir = '/nfs/export/scr2/cbeck/obs2013/180413/firs1/'
output_dir = '/export/cbeck/obs2013/firs_april2013/180413_reduced_630/'
;spawn,'mkdir '+output_dir

change_save = '/export/cbeck/obs2013/firs_april2013/180413_reduced_630/' 
;get_firs_dataprop,input_dir,change_save =change_save

; 16 cal   2 map  1 ff 0 dc

pp = 0
if pp eq 1 then begin

firs_630_ff,change_save = change_save,flat_file = 1,dark_file = 0,/plt,input_dir = input_dir,output_dir = output_dir,/no_av

firs_630_ff,change_save = change_save,flat_file = 3,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,/nopause


firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 5,retard = 88.,/no_av,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 6,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 5,retard = 88.,theta_pol = 45.,/nopause

endif

pp = 0
if pp eq 1 then begin

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,angle = 0

firs_630_obs,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  7,angle = 0


endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/180413/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 2,wavelen = 630.,pollimit = .01 ;,wwidth = 3

inpath = outpath
firs_create_html,filepath = inpath
firs_create_mainhtml



stop


end
