pro cal_200113_1083

; directory to input raw data
input_dir = '/export/cbeck/obs2013/200113/firs/'

; directory for output data
output_dir = '/export/cbeck/obs2013/200113/firs/reduced_200113/'

; change location of save file with data information if you do not have write
; permission in input_dir

; change_save = '/export/cbeck/obs2012/20121209/firs2/' 


pp = 1
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal, observations

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 01 20
types1 = [2,1,0,2,2,1,0,2,1,0,2,16,16,2,2,1,0]

pp = 1
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 2,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .2,/quit_column,sspeed = .5

firs_1083_ff,change_save = change_save,flat_file = 5,dark_file = 6,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .2,/quit_column,sspeed = .5,/pickx

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .2,/nopause,/quit_column,sspeed = .5,/pickx

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 11,darkindex= 2,change_save =change_save,theta_err = 5,retard = 82.,/nopause,gainindex = 2,/quit_column

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 12,darkindex= 2,change_save =change_save ,theta_err = 5,retard = 82.,theta_pol = 45.,/nopause,gainindex = 2,/quit_column

endif

pp = 1
if pp eq 1 then begin

cal_file =  11
tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  0,tmat_save = tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  4,tmat_save = tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  7,tmat_save = tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  13,tmat_save =  tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  14,tmat_save =  tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/average_cal,angle = 0,/catch_dead,smooth_width = 3


endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/200113/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .03

inpath = outpath
firs_create_html,filepath = inpath

firs_create_mainhtml


stop


end
