pro cal_210215_1565

; directory to input raw data
input_dir = '/data/cbeck/data1/obs2015/210215/'

; directory for output data
output_dir = '/data/cbeck/data1/obs2015/210215_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/data/cbeck/data1/obs2015/210215_reduced/'

;get_firs_dataprop,input_dir,change_save =change_save


; check output text file for the numbers of flat, dc, cal, observations

 
; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
;types1 = [2,1,0,2,1,0,16,16,1,0]

pp = 1
if pp eq 1 then begin

yyrange = [4,490,500,987]/2.


;firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/swap,yyrange = yyrange

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 2,darkindex= 0,gainindex = 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/swap

stop

firs_1083_ff,change_save = change_save,flat_file = 5,dark_file = 6,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/swap,yyrange = yyrange

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 7,darkindex= 1,gainindex = 1,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/swap

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/swap,yyrange = yyrange

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 11,darkindex= 2,gainindex = 2,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/swap

endif


pp = 1
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'
wavelength = 15650.

cal_file = 2

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  3,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap,/no_align ;,/check_lines

cal_file = 7
firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  4,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap ,/no_align


cal_file = 11
firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  12,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/swap ,/no_align







endif


inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2015/210215/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3.,wavelen = 1565.,pollimit = .002,iinput_dir = iinput_dir

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/export/cbeck/FIRS_archive/FIRS_archivemain.html'
 inpath = '/export/cbeck/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
