pro cal_210413_1083


input_dir = '/nfs/export/scr2/cbeck/obs2013/210413/firs2/'
output_dir = '/export/cbeck/obs2013/firs_april2013/210413_reduced/'

change_save = '/export/cbeck/obs2013/firs_april2013/210413_reduced/' 

;get_firs_dataprop,input_dir,change_save =change_save


;stop


; 16 cal   2 map  1 ff 0 dc

; 2013 04 21
types1 = [0,1,2,2,2,2,1,0,2,2,2,1,0,16,16,2,2,2,1,0,2,2]



pp = 0
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 0,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .15,/swap

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .05,/swap

firs_1083_ff,change_save = change_save,flat_file = 11,dark_file = 12,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .15,/swap

firs_1083_ff,change_save = change_save,flat_file = 18,dark_file = 19,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .15,/swap

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 13,darkindex= 3,change_save =change_save ,theta_err = 2,flat_file = flat_file,retard = 82.,gainindex = 3,/swap

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 14,darkindex= 3,change_save =change_save ,theta_err = 2,flat_file = flat_file,retard = 82.,gainindex = 3,/swap,theta_pol = 45.

endif




pp = 1
if pp eq 1 then begin

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  4,/swap,angle = 0.,wavelength = 10830.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  8,/swap,angle = 0.,wavelength = 10830.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  9,/swap,angle = 0.,wavelength = 10830.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 2,gainindex = 2,change_save =change_save,obsindex =  10,/swap,angle = 0.,wavelength = 10830.


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 3,gainindex = 3,change_save =change_save,obsindex =  15,/swap,angle = 0.,wavelength = 10830.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = 13,darkindex= 3,gainindex = 3,change_save =change_save,obsindex =  16,/swap,angle = 0.,wavelength = 10830.

endif



inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/210413/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .02,/ddeskew,/check_lines   ;,wwidth = 3,/pp

inpath = outpath
firs_create_html,filepath = inpath


firs_create_mainhtml


stop


end
