pro cal_220113_1565

; directory to input raw data
input_dir = '/export/cbeck/obs2013/220113/firs/'

; directory for output data
output_dir = '/export/cbeck/obs2013/220113/firs/reduced_220113/'

; change location of save file with data information if you do not have write
; permission in input_dir

; change_save = '/export/cbeck/obs2012/20121209/firs2/' 


pp = 0
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal, observations

;stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2013 01 22
types1 = [2,1,0,2,0,0,2,2,1,0,16,16,1,0,2,2,2,16,16,16]

pp = 1
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 2,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .3,/quit_column,sspeed = .5,/nopause ;,/pickx

stop

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 9,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .3,/quit_column,sspeed = .5,/nopause,/pickx

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 10,darkindex= 1,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 11,darkindex= 1,change_save =change_save ,theta_err = 5,flat_file = flat_file,theta_pol = 45.,retard = 116.,/quit_column,/nopause

endif


pp = 0
if pp eq 1 then begin

cal_file =  10
tmat_save =  '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'


firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  0,tmat_save = tmat_save,wavelength = 15650.,/no_align,/quit_column,offang = 0.

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 3,tmat_save = tmat_save,wavelength = 15650.,/quit_column,offang = 0.,/no_align

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 6,tmat_save = tmat_save,wavelength = 15650.,/quit_column,offang = 0.,/no_align

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 7,tmat_save = tmat_save,wavelength = 15650.,/quit_column,offang = 0.,/no_align

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 15,tmat_save = tmat_save,wavelength = 15650.,/quit_column,offang = 0.,/no_align

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex = 16,tmat_save =tmat_save ,wavelength = 15650.,/quit_column,offang = 0.,/no_align

endif

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2013/220113/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1565.,pollimit = .005

inpath = outpath
firs_create_html,filepath = inpath


firs_create_mainhtml


stop


end
