pro cal_220314_1083

; directory to input raw data
input_dir = '/data/cbeck/FIRS_test_220314/'

; directory for output data
output_dir = '/data/cbeck/FIRS_test_220314/220314_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save = '/data/cbeck/FIRS_test_220314/220314_reduced/'


pp = 1
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations, edit the rest below correspondingly

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2014 03 22
types1 = [1,1,0,16,16,16,2,2,2]

pp = 1
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file = 2,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,/nopause,/swap

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,/nopause,/swap

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 4,darkindex= 0,gainindex = 0,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,/nopause,/swap

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 3,darkindex= 0,gainindex = 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,theta_pol = 45.,retard = 83.,/quit_column,/nopause,/swap

endif


pp = 1
if pp eq 1 then begin

cal_file = 5
tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 7,tmat_save = tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/swap,/catch_dead

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 8,tmat_save =  tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/swap,/catch_dead

endif

pp = 1
if pp eq 1 then begin

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2014/220314/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .01

inpath = outpath
firs_create_html,filepath = inpath

inpath = '/export/cbeck/FIRS_archive/'
outfile = inpath + 'FIRS_archivemain.html'

firs_create_mainhtml,inpath =inpath,outfile = outfile

endif


stop


end
