pro cal_221014_1083

; directory to input raw data
input_dir = '/data/cbeck/data1/obs2014/221014/'

; directory for output data
output_dir = '/data/cbeck/data1/obs2014/221014_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/data/cbeck/data1/obs2014/221014_reduced/'

pp = 0
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations, edit the rest below correspondingly

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2014 03 22
;types1 = [1,0,2,1,0,2,2,1,0,2,2,16,16,1,0]

pp = 0
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 4,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,/swap,yyrange = [16,510,540,1023]/2. 

firs_1083_ff,change_save = change_save,flat_file = 8,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,/swap,yyrange = [16,510,540,1023]/2.

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 6,darkindex= 1,gainindex = 1,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,/nopause,/swap

endif


pp = 1
if pp eq 1 then begin

cal_file = 6
tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

ccal_file = '/data/cbeck/data1/obs2014/231014_reduced/xmat.firs.2.20141023.114515.sav'

cont_wl = [200,220]
pos_lines = [295,378]

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 0,tmat_save = tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl ;,/check_lines

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 1,tmat_save =  tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 2,tmat_save =  tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 3,tmat_save =  tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 1,change_save =change_save,obsindex = 5,tmat_save =  tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 1,change_save =change_save,obsindex = 6,tmat_save =  tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,pos_lines = pos_lines,cont_wl = cont_wl


endif

pp = 1
if pp eq 1 then begin

inpath = output_dir
outpath = '/export/cbeck/FIRS_archive/2014/221014/'

iinput_dir = '/data/cbeck/data1/obs2014/221014/'


generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3,wavelen = 1083.,pollimit = .01,iinput_dir = iinput_dir 

inpath = outpath
firs_create_html,filepath = inpath

inpath = '/export/cbeck/FIRS_archive/'
outfile = inpath + 'FIRS_archivemain.html'

firs_create_mainhtml,inpath =inpath,outfile = outfile

endif


stop


end
