pro cal_240517_1083

; directory to input raw data
input_dir = '/data/cbeck/data1/obs2017/DST_240517/firs_240517/'


; directory for output data
output_dir = '/data/cbeck/data1/obs2017/DST_240517/firs_240517_reduced/'

; data/cbeck/temp/T1079/firs_150616_reduced/'


; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/data/cbeck/data1/obs2017/DST_240517/firs_240517_reduced/'

;get_firs_dataprop,input_dir,change_save =change_save


;stop

; check output text file for the numbers of flat, dc, cal, observations

 
; coding for eventual automatic reduction, ignore

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
;types1 = [2,1,0,2,1,0,16,16,1,0]

pp = 0
if pp eq 1 then begin

yyrange = [0,500,520,1023]/2.

;yyrange = [0,495,515,1005]/2. 

firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 1,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1,bin = 2


firs_1083_ff,change_save = change_save,flat_file = 0,dark_file = 3,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1,bin = 2,/avdc_only

firs_1083_ff,change_save = change_save,flat_file = 6,dark_file = 7,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,yyrange = yyrange,int_limit = .1,bin = 2

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 8,darkindex= 2,gainindex = 1,change_save =change_save ,theta_err = 2.,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 0. ;,/no_av;,/nopause

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 9,darkindex= 2,gainindex = 1,change_save =change_save ,theta_err = 2.,flat_file = flat_file,retard = 83.,/quit_column,theta_pol = 45.;,/no_av;,/nopause

stop

endif



pp = 0
if pp eq 1 then begin

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'
wavelength = 10830.

;ccal_file = '/net/koa/export/data/cbeck/obs2016/dec2016/091216_reduced/xmat.firs.2.20160929.114240.sav'

cont_wl = [100,150]
pos_lines = [263,347]

cal_file = 8

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 1,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause, /no_align  ;,/check_lines


;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 1,gainindex = 0,change_save =change_save,obsindex =  4,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause,/no_align

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,ccal_file = ccal_file,darkindex= 1,gainindex = 1,change_save =change_save,obsindex =  5,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,cont_wl = cont_wl,pos_lines = pos_lines,/nopause  ;,/no_align


endif

stop


inpath = output_dir
outpath = '/data/cbeck/data1/obs2017/arch_temp/240517/'

;/export/raid2/cbeck/work/FIRS_archive/2016/170316/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3.,wavelen = 1083.,pollimit = .015,iinput_dir = iinput_dir,/check_lines

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/export/raid2/cbeck/work/FIRS_archive/FIRS_archivemain.html'
inpath = '/export/raid2/cbeck/work/FIRS_archive/'
;firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
