pro cal_270914_1083

; directory to input raw data
input_dir = '/net/koa/export/data/cbeck/data1/obs2014/20140927/'

; directory for output data
output_dir = '/net/koa/export/data/cbeck/data1/obs2014/20140927_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir

change_save =  '/net/koa/export/data/cbeck/data1/obs2014/20140927_reduced/'


pp = 0
if pp eq 1 then begin
get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations, edit the rest below correspondingly

stop

endif

; coding for eventual automatic reduction, ignore
; 16 cal   2 map  1 ff 0 dc

; 2014 03 22
types1 = [2,2,1,0,2]

pp = 0
if pp eq 1 then begin

firs_1083_ff,change_save = change_save,flat_file = 2,dark_file = 3,/plt,input_dir = input_dir,output_dir = output_dir,int_limit = .1,/quit_column,sspeed = .5,/swap,/no_av,yyrange = [0,490,510,1023]/2.,sshift = [0,-4.]

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save,theta_err = 5,flat_file = flat_file,retard = 83.,/quit_column,/nopause,/swap

endif


pp = 1
if pp eq 1 then begin

cal_file = 0
tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

ccal_file = '/net/koa/export/data/cbeck/data1/obs2014/20140929_reduced/xmat.firs.2.20140929.130950.sav'

cont_wl = [200,220]
pos_lines = [292,377]

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 1,tmat_save = tmat_save,wavelength = 10830.,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,cont_wl = cont_wl,pos_lines = pos_lines

;firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex = 4,tmat_save =  tmat_save,wavelength = 10830.,/no_align,/quit_column,offang = 0.,/swap,/catch_dead,ccal_file =ccal_file,cont_wl = cont_wl

endif

pp = 1
if pp eq 1 then begin

inpath = output_dir
outpath = '/net/cbeck-pc1/export/cbeck/FIRS_archive/2014/270914/'

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 4,wavelen = 1083.,pollimit = .01

inpath = outpath
firs_create_html,filepath = inpath

inpath = '/net/cbeck-pc1/export/cbeck/FIRS_archive/'
outfile = inpath + 'FIRS_archivemain.html'

firs_create_mainhtml,inpath =inpath,outfile = outfile

endif


stop


end
