pro firs_1565_fringes



input_dir = '/export/cbeck/obs2012/20121212/firs2/'
output_dir = '/export/cbeck/obs2012/20121212/firs2/reduced_20121212/'

restore,'/export/cbeck/obs2012/20121212/firs2/reduced_20121212/firs.2.20121212.091805.reduced_temp.dat.sav'



full_spec = fltarr(201.000,380.000,190*4)


a = fltarr(4,201,380,4)




openr,1,'/export/cbeck/obs2012/20121212/firs2/reduced_20121212/firs.2.20121212.091805.reduced_temp.dat'


for k = 0,189 do begin & readu,1,a & for kk = 0,3 do begin & full_spec(*,*,kk*190+k) = a(kk,*,*,0) & endfor

close,1

ii1a = total(full_spec(*,*,0:189),3)/190.
ii2a = total(full_spec(*,*,190:379),3)/190.
ii3a = total(full_spec(*,*,380:569),3)/190.
ii4a = total(full_spec(*,*,570:759),3)/190.


dy_final = 379
dx_final = 200


ilobes = [95,170]

   n_per = 24.  
   xx = findgen(dx_final + 1)
   xx = xx/180.*!pi
   weights = fltarr(dx_final+1)+1.
   a = [n_per,-0.8,.1,1]

ii1 = ii1a/smooth(ii1a,19,/edge_truncate) 
y = total(ii1,2)/(dy_final+1.)  &  a = [n_per,-0.8,.1,1] &  
weights = fltarr(dx_final+1)+1. & 
weights(ilobes(0)-10:ilobes(0)+10) = 0. & 
weights(ilobes(1)-10:ilobes(1)+10) = 0. & 
erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.))  & aini = a   


aa = fltarr(12,19)

for kk = 0.,18 do begin & y = total(ii1(*,kk*20:(kk+1)*20-1.),2)/20. & a = [aini(0),0.0000,0.000,aini(1),0.0001,0.00,aini(2),0.00000,0.0000,aini(3),0.000,0.000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,0,0,1,1,0,1,0,0,1,0,0]) & aa(*,kk) = a & endfor

aa_compl = fltarr(12,dy_final+1)

for k = 0,11 do begin & aa_compl(k,*) = spline( findgen(19)*20.,reform(aa(k,*)), findgen(dy_final+1),/double) & endfor


aa_compl(9,*) = 1. & corr1 = ii1 - ii1 & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa_compl(*,kkkk)),f & corr1(*,kkkk) = f & endfor 



& corr = ii1 - ii1 & aa = fltarr(21,dy_final+1) & for kkkk = 0,dy_final do begin & y = reform(ii1(*,kkkk)) & a = [aini(0),0.0001,0.00,aini(1),0.00,0.00,aini(2),0.00001,0.0000,aini(3),0.000,0.000,aini(0),0.000,0.00,aini(1),0.00,0.00,aini(2),0.0000,0.0000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,1,0,1,0,0,1,1,0,1,0,0,1,0,0,1,0,0,1,0,0]) & aa(*,kkkk) = a & corr(*,kkkk) = erg & endfor 


for kk = 0,20 do begin & aa(kk,*) = median(reform(aa(kk,*)),17) & aa(9,*) = 1. & corr1 = ii1 - ii1 & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa(*,kkkk)),f & corr1(*,kkkk) = f & endfor 





 
  for kk = 0,n_slits -1 do begin & ii = reform( ibeams_merged(kk,*,*,0)) & ii1 = ii/smooth(ii,19,/edge_truncate)  & y = total(ii1,2)/(dy_final+1.)  &  a = [n_per,-0.8,.1,1] &  weights = fltarr(dx_final+1)+1. & weights(ilobes(0)-10+oofset(kk):ilobes(0)+10+oofset(kk)) = 0. & weights(ilobes(1)-10+oofset(kk):ilobes(1)+10+oofset(kk)) = 0. & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.))  & aini = a   & corr = ii - ii & aa = fltarr(12,dy_final+1) & for kkkk = 0,dy_final do begin & y = reform(ii1(*,kkkk)) & a = [aini(0),0.000,0.00,aini(1),0.001,0.00,aini(2),0.0000,0.0000,aini(3),0.001,0.000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,0,0,1,1,0,1,0,0,1,1,0]) & aa(*,kkkk) = a & corr(*,kkkk) = erg & endfor & aa(9,*) = 1.  & corr1 = ii - ii & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa(*,kkkk)),f & corr1(*,kkkk) = f & endfor & ii = ii/corr1 &  ibeams_merged(kk,*,*,0) = ii & endfor





erg = read_directory(input_dir,filter ='*.sav')
outfile = erg.files
restore,input_dir+outfile(0)


; 2012 12 12 asc
types1 = [0,1,2,2,1,16,16,1,0,2,2,2,16,16,16,16,1]

;  2012 12 12 asc
;darkbasefile = bbasefile1(0)
darkbasefile = bbasefile1(8)

;  2012 12 12 asc
;flatbasefile = bbasefile1(1)
;flatbasefile = bbasefile1(4)
flatbasefile = bbasefile1(7)


ergdc = read_directory(output_dir,filter ='*dc*')
restore,output_dir + ergdc.files(1)

erggain = read_directory(output_dir,filter ='*gain*')

gainfile = output_dir + erggain.files(2)

restore,gainfile

restore,output_dir+'ff.'+flatbasefile+'sav'


ff_img = ff_img - dc

ww = where(ff_img lt 0)
if ww(0) ne -1 then ff_img(ww) = 1.
ww = where(ff_img eq 0)
if ww(0) ne -1 then ff_img(ww) = 1.


ibeams = fltarr(n_slits,2,dx+1,dy+1,4)

dum = ff_img

for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

  ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

  for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/gaintable(kk,1,*,*,kkk) & endfor & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor

xx = findgen(dx_final + 1)
xx = xx/180.*!pi

n_per = 24.  
weights = fltarr(dx_final+1)+1.

corr = gaintable - gaintable

aout = fltarr(n_slits,2,dy_final+1,4,4)

;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) = erg & endfor & endfor & endfor


for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) &y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a &  for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) = erg & endfor & endfor & endfor


;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(ibeams1(k,0,*,*,kk)/corr(k,0,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a & for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [1,1,1,1]) & aout(k,0,kkk,kk,*) = a & corr(k,0,*,kkk,kk) = corr(k,0,*,kkk,kk)*erg & endfor & ii = reform(ibeams1(k,1,*,*,kk)/corr(k,1,*,*,kk)) & ii1 = ii/smooth(ii,19,/edge_truncate) &y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a &  for kkk = 0.,dy_final do begin & y = reform(ii1(*,kkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [1,1,1,1]) & aout(k,1,kkk,kk,*) = a   & corr(k,1,*,kkk,kk) =corr(k,1,*,kkk,kk)* erg & endfor & endfor & endfor


;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & ii = reform(aout(k,0,*,kk,0)) & ii = median(ii,3) & aout(k,0,*,kk,0) = ii &  ii = reform(aout(k,0,*,kk,1)) & ii = median(ii,3) & aout(k,0,*,kk,1) = ii &  ii = reform(aout(k,0,*,kk,2)) & ii = median(ii,3) & aout(k,0,*,kk,2) = ii &  ii = reform(aout(k,0,*,kk,3)) & ii = median(ii,3) & aout(k,0,*,kk,3) = ii &  ii = reform(aout(k,1,*,kk,0)) & ii = median(ii,3) & aout(k,1,*,kk,0) = ii &  ii = reform(aout(k,1,*,kk,1)) & ii = median(ii,3) & aout(k,1,*,kk,1) = ii &  ii = reform(aout(k,1,*,kk,2)) & ii = median(ii,3) & aout(k,1,*,kk,2) = ii &  ii = reform(aout(k,1,*,kk,3)) & ii = median(ii,3) & aout(k,1,*,kk,3) = ii & endfor & endfor
;corr1 = corr - corr
;for k = 0,n_slits -1 do begin &  for kk = 0,3 do begin & for kkk = 0,dy_final do begin & sin_var,xx,reform(aout(k,0,kkk,kk,*)),f & corr1(k,0,*,kkk,kk) = f & sin_var,xx,reform(aout(k,1,kkk,kk,*)),f & corr1(k,1,*,kkk,kk) = f  & endfor & endfor & endfor

fringe_corr = corr

save,fringe_corr,aangle,dx,dy,dx_final,dy_final,posx,posy,posx_final,posy_final,gaintable,gaintablecoarse,cchi,n_slits,pposref,mean_slits,mean_slitscoarse,mean_slits1,filename = gainfile

stop

ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/gaintable(kk,1,*,*,kkk) & endfor & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor


for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk)/fringe_corr(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk)/fringe_corr(kk,1,*,*,kkk) & endfor & endfor




end
