pro firs_focus

;restore,'/export/cbeck/FIRS_data/sanka_obs1_20120625.sav'

restore,'/export/cbeck/FIRS_data/asc_obs1_20121212.sav'

sanka1 = img1
sanka2 = img2
sanka3 = img3

restore,'/export/cbeck/FIRS_data/ali_obs2_20100202.sav'
ali1 =  img1
ali2 =  img2
ali3 =  img3

restore,'/export/cbeck/FIRS_data/ali_obs2_20100202.sav'
ali1 =  img1
ali2 =  img2
ali3 =  img3

scale = 1.5

laodct,0
window,0,xs = 387*scale,ys = 450*scale
tvscl,congrid(reform(sanka2(0,0,*,*,0)),387/2.*scale,450*scale,/interp),0,0
tvscl,congrid(reform(sanka2(0,1,*,*,0)),387/2.*scale,450*scale,/interp),387/2.*scale,0
draw_rec,[49,120],[392,  442],/device
draw_rec,[49,120]+387*scale/2.,[392,  442],/device

pp = 0
if pp eq 1 then begin


scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/asc_beams.ps',xs = 3.87*scale,ys = 4.5*scale,bits_per_pixel = 8,/color
tvscl,congrid(reform(sanka2(1,0,*,*,0)),387/2.*scale,450*scale,/interp),0*387*scale,0*scale,xs = 387/2.*scale*10.,ys = 450*scale *10.
tvscl,congrid(reform(sanka2(1,1,*,*,0)),387/2.*scale,450*scale,/interp),1*387/2.*scale*10,0*scale,xs = 387/2.*scale*10.,ys = 450*scale *10.
laodct,41
;draw_rec,[0,387*scale]*10,[93,132]*10,color =1,/device,thick = 2

draw_rec,[0,387*scale]*10,[200,300]*10,color =1,/device,thick = 2

laodct,0

device,/close
set_plot,'X'

scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/asc_beams_magn.ps',xs = 3.87*scale,ys = 1.*scale,bits_per_pixel = 8,/color
tvscl,congrid(reform(sanka2(1,0,*,250:350,0)),387/2.*scale,100*scale,/interp),0*387*scale,0*scale,xs = 387/2.*scale*10.,ys = 100*scale *10.
tvscl,congrid(reform(sanka2(1,1,*,250:350,0)),387/2.*scale,100*scale,/interp),1*387/2.*scale*10,0*scale,xs = 387/2.*scale*10.,ys = 100*scale *10.

; 120:220

device,/close
set_plot,'X'


stop





scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/ali_beams.ps',xs = 3.87*scale,ys = 4.5*scale,bits_per_pixel = 8,/color
tvscl,congrid(reform(ali2(1,0,*,*,0)),387/2.*scale,450*scale,/interp),0*387*scale,0*scale,xs = 387/2.*scale*10.,ys = 450*scale *10.
tvscl,congrid(reform(ali2(1,1,*,*,0)),387/2.*scale,450*scale,/interp),1*387/2.*scale*10,0*scale,xs = 387/2.*scale*10.,ys = 450*scale *10.
laodct,41
draw_rec,[0,387*scale]*10,([265,311]-0)*10,color =1,/device,thick = 2
laodct,0
device,/close
set_plot,'X'

scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/ali_beams_magn.ps',xs = 3.87*scale,ys = 1.*scale,bits_per_pixel = 8,/color
tvscl,congrid(reform(ali2(1,0,*,330:430,0)),387/2.*scale,100*scale,/interp),0*387*scale,0*scale,xs = 387/2.*scale*10.,ys = 100*scale *10.
tvscl,congrid(reform(ali2(1,1,*,330:430,0)),387/2.*scale,100*scale,/interp),1*387/2.*scale*10,0*scale,xs = 387/2.*scale*10.,ys = 100*scale *10.

device,/close
set_plot,'X'


laodct,41
cchars = .7

set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/cuts.ps',xs = 8,ys = 8,bits_per_pixel = 8,/color
!p.multi = [2,1,2]
plot,sanka2(1,0,20,120:220,0),yr = [400,900],/ystyle,charsize = cchars
oplot,sanka2(1,1,20,120:220,0),color =240
draw_rec,[20,60],[550,890],/data

plot,ali2(1,0,50,330:430,0),yr = [500,2000],/ystyle,charsize = cchars,psym = -1
oplot,ali2(1,1,50,330:430,0),color =240

device,/close
set_plot,'X'

endif

restore,'/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/firs.1.20100205.130538._upperbeam_reduced.dat.sav'
ic1 = ic

restore,'/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/firs.1.20100205.130538._lowerbeam_reduced.dat.sav'
ic2 = ic     

restore,'/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/firs.1.20100205.130538.reduced.dat.sav'
ic3 = ic

restore,'/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/firs.1.20100205.123424.reduced.dat.sav' 
ic4 = ic

 restore,'/export/cbeck/FIRS_data/ali20100202/firs1/reduced_20100205/firs.1.20100202.084147.reduced.dat.sav'
ic5 = ic


pp = 0
if pp eq 1 then begin 
laodct,0
scale = 1.
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/grid_ali.ps',xs = 2*5.8*scale,ys = 2.4*scale*2,bits_per_pixel = 8,/color

tvscl,congrid(ic1,580,898*.08/.3,/interp),0,0,xs = 5800,ys = 2400
tvscl,congrid(ic2,580,898*.08/.3,/interp),5800,0,xs = 5800,ys = 2400
tvscl,congrid(ic3,580,898*.08/.3,/interp),0,2400,xs = 5800,ys = 2400
tvscl,congrid(ic4,580,898*.08/.3,/interp),5800,2400,xs = 5800,ys = 2400

xyouts,findgen(2)/2.+.05,.05,['upper beam','lower beam'],charsize =cchars,/normal

xyouts,findgen(2)/2.+.05,.95,['merged beams','target'],charsize =cchars,/normal

device,/close
set_plot,'X'

endif


ic5 = ic5 /mean(ic5(312:400,550:800))
ic55 = ic5 - ic5
ff = total(ic5(0:144,*),1)
corr = ff/smooth(ff,21)
for k = 0,144 do begin & ic55(k,*) = ic5(k,*)/corr & endfor

ff = total(ic5(145:289,*),1)
corr = ff/smooth(ff,21)
for k = 145,289 do begin & ic55(k,*) = ic5(k,*)/corr & endfor

ff = total(ic5(290:434,*),1)
corr = ff/smooth(ff,21)
for k = 290,434 do begin & ic55(k,*) = ic5(k,*)/corr & endfor
ff = total(ic5(435:579,*),1)
corr = ff/smooth(ff,21)
for k = 435,579 do begin & ic55(k,*) = ic5(k,*)/corr & endfor


pp = 0 
if pp eq 1 then begin

laodct,0
scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/best_scan_ali.ps',xs = 5.8*scale,ys = 2.4*scale*2,bits_per_pixel = 8,/color

tvscl,congrid(ic5,580*scale,900*.08/.3*scale,/interp) > .35 < 1.2,0,0,xs = 5800*scale,ys =2400*scale

tvscl,congrid(ic55,580*scale,900*.08/.3*scale,/interp) > .35 < 1.2,0,2400*scale,xs = 5800*scale,ys =2400*scale

plots,[0,5800*scale],[0,0]+2400*scale,/device,thick = 3

xyouts,.05,findgen(2)/2.+.05,['Uncorrected','Corrected'],charsize = cchars,/normal

device,/close
set_plot,'X'

endif


erg1 = readfits('/export/cbeck/obs2012/20121212/121212.134918.0.ccc04.a-icc.slitjaw.target.fits',exten = 1)

erg2 = readfits('/export/cbeck/obs2012/20121212/121212.140417.0.ccc04.a-icc.slitjaw.linegrid.fits',exten = 1)

scale = .75

set_plot,'PS'
device,filename ='/export/cbeck/work/FIRS/firs_630/sj_target.ps',xs = 10.24*scale,ys = 2.9*scale*2,bits_per_pixel = 8,/color

tvscl,congrid(reform(erg1),1024*scale,290*scale,/interp),0,0,xs = 10240*scale,ys = 2900*scale
tvscl,congrid(reform(erg2),1024*scale,290*scale,/interp),0,2900*scale,xs = 10240*scale,ys = 2900*scale

device,/close
set_plot,'X'






 restore,'/export/cbeck/obs2012/20121212/firs1/reduced_20121212/firs.1.20121212.091801.reduced.dat.sav'
ic6 = ic

restore,'/export/cbeck/obs2012/20121212/firs1/reduced_20121212/firs.1.20121212.100311.reduced.dat.sav'
ic7 = ic

ic6 = ic6 /mean(ic6(312:400,550:800))
ic66 = ic6 - ic6
ff = total(ic6(0:189,*),1)
corr = ff/smooth(ff,21)
for k = 0,189 do begin & ic66(k,*) = ic6(k,*)/corr & endfor
ff = total(ic6(190:379,*),1)
corr = ff/smooth(ff,21)
for k = 190,379 do begin & ic66(k,*) = ic6(k,*)/corr & endfor
ff = total(ic6(380:569,*),1)
corr = ff/smooth(ff,21)
for k = 380,569 do begin & ic66(k,*) = ic6(k,*)/corr & endfor
ff = total(ic6(570:759,*),1)
corr = ff/smooth(ff,21)
for k = 570,759 do begin & ic66(k,*) = ic6(k,*)/corr & endfor

ic7 = ic7 /mean(ic7(312:400,550:800))
ic77 = ic7 - ic7
ff = total(ic7(0:189,*),1)
corr = ff/smooth(ff,21)
for k = 0,189 do begin & ic77(k,*) = ic7(k,*)/corr & endfor
ff = total(ic7(190:379,*),1)
corr = ff/smooth(ff,21)
for k = 190,379 do begin & ic77(k,*) = ic7(k,*)/corr & endfor
ff = total(ic7(380:569,*),1)
corr = ff/smooth(ff,21)
for k = 380,569 do begin & ic77(k,*) = ic7(k,*)/corr & endfor
ff = total(ic7(570:759,*),1)
corr = ff/smooth(ff,21)
for k = 570,759 do begin & ic77(k,*) = ic7(k,*)/corr & endfor


pp = 0
if pp eq 1 then begin

laodct,0
scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/dec2012_scans.ps',xs = 7.6*scale,ys = 2.24*scale*2,bits_per_pixel = 8,/color


tvscl,congrid(ic66,760*scale,840*.08/.3*scale,/interp) > .35 < 1.2,0,0,xs = 7600*scale,ys =2240*scale

tvscl,congrid(ic77,760*scale,840*.08/.3*scale,/interp) > .35 < 1.3,0,2240*scale,xs = 7600*scale,ys =2240*scale

plots,[0,7600*scale],[0,0]+2240*scale,/device,thick = 3

device,/close
set_plot,'X'
stop

endif


read_polis_op_hdr,'/export/cbeck/obs2011/06apr11_polis/polisfe_06apr11/fe20110406_081242.001',op_hdr,/v,/no_swap

pos = get_pointer(0,400,600)
read_polis_sc_data,'/export/cbeck/obs2011/06apr11_polis/polisfe_06apr11/fe20110406_081242.001',pos,i,q,u,v

read_polis_sc_data,'/export/cbeck/obs2011/06apr11_polis/polisfe_06apr11/fe20110406_082538.003',pos,i,q,u,v

i = swap_endian(i)

pos = get_pointer(0,400,600)
read_polis_sc_data,'/export/cbeck/obs2011/06apr11_polis/polisfe_06apr11/fe20110406_081913.002',pos,dc,q,u,v

dc = swap_endian(dc)
i = i -dc

beam1 = i(*,0:199)
beam2 = i(*,200:399)

beam2 = shift(beam2,-4,-23)



pp = 0 
if pp eq 1 then begin

scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/polis_beams.ps',xs = 2*2.*scale,ys = 6.*scale,bits_per_pixel = 8,/color
tvscl,congrid(transpose(beam1),200*scale,600*scale,/interp),0,0,xs = 200.*scale*10.,ys = 600*scale *10.
tvscl,congrid(transpose(beam2),200*scale,600*scale,/interp),200.*scale*10,0*scale,xs = 200.*scale*10.,ys = 600*scale *10.
laodct,41
draw_rec,[0,200*scale*2*10],[570,595]*10*scale,color =1,/device,thick = 2
laodct,0

device,/close
set_plot,'X'

beam1 = transpose(beam1)
beam2 = transpose(beam2)

scale = 1.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/polis_beams_magn.ps',xs = 2*scale*2,ys = 1.*scale,bits_per_pixel = 8,/color
tvscl,congrid(beam1(*,570:599),200.*scale,100*scale,/interp),0,0,xs = scale*200*10.,ys = 100*scale*10.
tvscl,congrid(beam2(*,570:599),200.*scale,100*scale,/interp),200*scale*10,0,xs = scale*200*10.,ys = 100*scale*10.

device,/close
set_plot,'X'

laodct,41
cchars =.8
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/cuts_polis.ps',xs = 8,ys = 4,bits_per_pixel = 8,/color
!p.multi = 0
plot,beam1(50,570:*),charsize = cchars,yr = [1500,5000],/ystyle,psym = -1
oplot,shift(reform(beam2(50,570:*)),-1)/1.22,color =240


device,/close
set_plot,'X'

endif


restore,'/export/cbeck/obs2011/06apr11_polis/reduced_fe_06apr11/fe20110406_113417.016.cal_merged.sav


kontint = congrid(kontint,100,600*.145/.36,/interp)

laodct,0
scale = 2.5
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/grid_polis.ps',xs = 1*scale,ys = 2.4*scale,bits_per_pixel = 8,/color

tvscl,congrid(kontint,100*scale,240*scale,/interp),0,0,xs = 1000*scale,ys = 2400*scale



device,/close
set_plot,'X'

restore,'/export/cbeck/obs2011/06apr11_polis/reduced_fe_06apr11/fe20110406_082538.003.cal_merged.sav'



kontint = congrid(kontint,150,600*.145/.36,/interp)

laodct,0
scale = 4.
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/spot_polis.ps',xs = 1.5*scale,ys = 2.4*scale,bits_per_pixel = 8,/color

tvscl,congrid(kontint,150*scale,240*scale,/interp),0,0,xs = 1500*scale,ys = 2400*scale



device,/close
set_plot,'X'

restore,'/export/cbeck/obs2011/13apr11_polis/polisfe_13apr11/reduced_fe/fe20110413_081644.005.cal_merged.sav'



kontint = congrid(kontint,150,600*.145/.36,/interp)

laodct,0
scale = 6.
set_plot,'PS'
device,filename = '/export/cbeck/work/FIRS/firs_630/spot_polis_1.ps',xs = 1.5*scale,ys = 2.4*scale,bits_per_pixel = 8,/color

tvscl,congrid(kontint,150*scale,240*scale,/interp),0,0,xs = 1500*scale,ys = 2400*scale



device,/close
set_plot,'X'


stop

ii1 = reform(total(sanka3(0,0,*,*,0),4)/900.)
ii2 = reform(total(sanka3(0,1,*,*,0),4)/900.)


xx = [45+findgen(50),165+findgen(10),195+findgen(10),270+findgen(20)]

erg = poly_fit(xx,ii1(xx),5,/double)
yy =0.
for k =0.,5 do begin & yy = yy + findgen(373)^k*erg(k) & endfor
ii1 =  ii1 / yy

erg = poly_fit(xx,ii2(xx),5,/double)
yy1 =0.
for k =0.,5 do begin & yy1 = yy1 + findgen(373)^k*erg(k) & endfor
ii2 =  ii2 / yy1

ftsread,data,6300,6304,xlam = xlam
xlam = xlam /10.
data = swap_endian(data)/10000.

ll = 630.02+findgen(373)*1./1000.

laodct,41
device,decomposed = 0

window,2
!p.multi = [2,1,2]
plot,ll,ii1,xr = [630.2,630.22],/xstyle
oplot,ll,ii2,color =240
;oplot,xlam,data,color =80

plot,ll,ii1,xr = [630.27,630.29],/xstyle
oplot,ll,ii2,color =240
;oplot,xlam,data,color =80




stop


end
